package net.minecraftforge.client.model.pipeline;

import java.util.Arrays;

import net.minecraft.client.renderer.WorldRenderer;
import net.minecraft.client.renderer.vertex.VertexFormat;
import net.minecraft.util.BlockPos;
import net.minecraft.util.EnumFacing;

/**
 * Assumes VertexFormatElement is present in the WorlRenderer's vertex format.
 */
public class WorldRendererConsumer implements IVertexConsumer
{
    private final WorldRenderer renderer;
    private final int[] quadData;
    private int v = 0;
    private BlockPos offset = BlockPos.field_177992_a;

    public WorldRendererConsumer(WorldRenderer renderer)
    {
        super();
        this.renderer = renderer;
        quadData = new int[renderer.func_178973_g().func_177338_f()/* / 4 * 4 */];
    }

    public VertexFormat getVertexFormat()
    {
        return renderer.func_178973_g();
    }

    public void put(int e, float... data)
    {
        LightUtil.pack(data, quadData, getVertexFormat(), v, e);
        if(e == getVertexFormat().func_177345_h() - 1)
        {
            v++;
            if(v == 4)
            {
                renderer.func_178981_a(quadData);
                renderer.func_178987_a(offset.func_177958_n(), offset.func_177956_o(), offset.func_177952_p());
                Arrays.fill(quadData, 0);
                v = 0;
            }
        }
    }

    public void setOffset(BlockPos offset)
    {
        this.offset = new BlockPos(offset);
    }

    public void setQuadTint(int tint) {}
    public void setQuadOrientation(EnumFacing orientation) {}
    public void setQuadColored() {}
}